const int latchPin = 4;  // Latch pin of 74HC595 D5-re
const int clockPin = 7;  // Clock pin of 74HC595 D6-ra
const int dataPin = 8;   // Data pin of 74HC595 D4-re
byte leds = 0;           // A kiírandó LED bitminta tárolója

void setup() {
  pinMode(latchPin, OUTPUT);
  pinMode(dataPin, OUTPUT);  
  pinMode(clockPin, OUTPUT);
}

void loop() {
  leds = 0;                   // Kezdetben minden LED kikapcsolva
  updateShiftRegister();      // Kijelzés frissítése
  delay(500);
  for (int i = 0; i < 8; i++) // Egyenként felkapcsoljuk a LED-eket
  {
    bitSet(leds, i);          // A 'leds' következő bitjét '1'-b állítja
    updateShiftRegister();    // Kijelzés frissítése
    delay(500);
  }
}

void updateShiftRegister() {
   digitalWrite(latchPin, LOW);
   shiftOut(dataPin, clockPin, MSBFIRST, ~leds);
   shiftOut(dataPin, clockPin, MSBFIRST, 0xF1);
   digitalWrite(latchPin, HIGH);
}
