const int latchPin = 4;  // Latch pin of 74HC595 D5-re
const int clockPin = 7;  // Clock pin of 74HC595 D6-ra
const int dataPin = 8;   // Data pin of 74HC595 D4-re
byte leds = 0;           // A kiírandó LED bitminta tárolója
byte digit = 0xF0;       // A kiválasztott számjegy
const byte DIGIT_SELECT[] = {0xF1, 0xF2, 0xF4, 0xF8};

void setup() {
  pinMode(latchPin, OUTPUT);
  pinMode(dataPin, OUTPUT);
  pinMode(clockPin, OUTPUT);
}

void loop() {
  for (int d = 0; d < 4; d++) {
    digit = DIGIT_SELECT[d];
    leds = 0;                   // Kezdetben minden LED kikapcsolva
    updateShiftRegister();      // Kijelzés frissítése
    delay(500);
    for (int i = 0; i < 8; i++) // Egyenként felkapcsoljuk a LED-eket
    {
      bitSet(leds, i);          // A 'leds' következő bitjét '1'-b állítja
      updateShiftRegister();    // Kijelzés frissítése
      delay(500);
    }
  }
}

void updateShiftRegister() {
  digitalWrite(latchPin, LOW);
  shiftOut(dataPin, clockPin, MSBFIRST, ~leds);
  shiftOut(dataPin, clockPin, MSBFIRST, digit);
  digitalWrite(latchPin, HIGH);
}
